;/*****************************************/;
;/* Demo Program For Graphic LCD DV-12864 */;
;/* Hardware  : ET-CPSB31 V2.0            */;
;/* Complier  : Cross-32  V2.0            */;
;/* Function  : Show OscilloScope Picture */;
;/*****************************************/;
;
;/****************************/;
;/* Equate List Register CPU */;
;/****************************/;
;
P0:         EQU     080H
SP:         EQU     081H
DPL:        EQU     082H
DPH:        EQU     083H
PCON:       EQU     087H
TCON:       EQU     088H
TMOD:       EQU     089H
TL0:        EQU     08AH
TL1:        EQU     08BH
TH0:        EQU     08CH
TH1:        EQU     08DH
P1:         EQU     090H
SCON:       EQU     098H
SBUF:       EQU     099H
P2:         EQU     0A0H
IE:         EQU     0A8H
P3:         EQU     0B0H
IP:         EQU     0B8H
T2CON:      EQU     0C8H
RCAP2L:     EQU     0CAH
RCAP2H:     EQU     0CBH
TL2:        EQU     0CCH
TH2:        EQU     0CDH
PSW:        EQU     0D0H
ACC:        EQU     0E0H
B:          EQU     0F0H
;
P0.0:       EQU     080H
P0.1:       EQU     081H
P0.2:       EQU     082H
P0.3:       EQU     083H
P0.4:       EQU     084H
P0.5:       EQU     085H
P0.6:       EQU     086H
P0.7:       EQU     087H
IT0:        EQU     088H
IE0:        EQU     089H
IT1:        EQU     08AH
IE1:        EQU     08BH
TR0:        EQU     08CH
TF0:        EQU     08DH
TR1:        EQU     08EH
TF1:        EQU     08FH
P1.0:       EQU     090H
P1.1:       EQU     091H
P1.2:       EQU     092H
P1.3:       EQU     093H
P1.4:       EQU     094H
P1.5:       EQU     095H
P1.6:       EQU     096H
P1.7:       EQU     097H
RI:         EQU     098H
TI:         EQU     099H
RB8:        EQU     09AH
TB8:        EQU     09BH
REN:        EQU     09CH
SM2:        EQU     09DH
SM1:        EQU     09EH
SM0:        EQU     09FH
P2.0:       EQU     0A0H
P2.1:       EQU     0A1H
P2.2:       EQU     0A2H
P2.3:       EQU     0A3H
P2.4:       EQU     0A4H
P2.5:       EQU     0A5H
P2.6:       EQU     0A6H
P2.7:       EQU     0A7H
EX0:        EQU     0A8H
ET0:        EQU     0A9H
EX1:        EQU     0AAH
ET1:        EQU     0ABH
ES:         EQU     0ACH
ET2:        EQU     0ADH
EA:         EQU     0AFH
P3.0:       EQU     0B0H
P3.1:       EQU     0B1H
P3.2:       EQU     0B2H
P3.3:       EQU     0B3H
P3.4:       EQU     0B4H
P3.5:       EQU     0B5H
P3.6:       EQU     0B6H
P3.7:       EQU     0B7H
PX0:        EQU     0B8H
PT0:        EQU     0B9H
PX1:        EQU     0BAH
PT1:        EQU     0BBH
PS:         EQU     0BCH
PT2:        EQU     0BDH
T2CP:       EQU     0C8H
T2C:        EQU     0C9H
TR2:        EQU     0CAH
EXEN2:      EQU     0CBH
TLCK:       EQU     0CCH
RCLK:       EQU     0CDH
EXF2:       EQU     0CEH
TF2:        EQU     0CFH
P:          EQU     0D0H
OV:         EQU     0D2H
RS0:        EQU     0D3H
RS1:        EQU     0D4H
F0:         EQU     0D5H
AC:         EQU     0D6H
CY:         EQU     0D7H
ACC.0:      EQU     0E0H
ACC.1:      EQU     0E1H
ACC.2:      EQU     0E2H
ACC.3:      EQU     0E3H
ACC.4:      EQU     0E4H
ACC.5:      EQU     0E5H
ACC.6:      EQU     0E6H
ACC.7:      EQU     0E7H
B.0:        EQU     0F0H
B.1:        EQU     0F1H
B.2:        EQU     0F2H
B.3:        EQU     0F3H
B.4:        EQU     0F4H
B.5:        EQU     0F5H
B.6:        EQU     0F6H
B.7:        EQU     0F7H

;/***************************************/;
;/* Equate List Port I/O ET-CPSB31 V2.0 */;
;/***************************************/;
;
WR_COMM1:   EQU     0E0C4H                  ; Write Instruction Page1
RD_COMM1:   EQU     0E0C5H                  ; Reda Busy flag & Address Page1
WR_DATA1:   EQU     0E0C6H                  ; Write Data Page1
RD_DATA1:   EQU     0E0C7H                  ; Read Data Page1
;
WR_COMM2:   EQU     0E0C8H                  ; Write Instruction Page2
RD_COMM2:   EQU     0E0C9H                  ; Reda Busy flag & Address Page2
WR_DATA2:   EQU     0E0CAH                  ; Write Data Page2
RD_DATA2:   EQU     0E0CBH                  ; Read Data Page2

            ORG     22H                     ; Start CPU-RAM Buffer
X_ADDR1:    DFS     1                       ; X-Address1 Buffer
X_ADDR2:    DFS     1                       ; X-Address2 Buffer
Y_ADDR1:    DFS     1                       ; Y-Address1 Buffer
Y_ADDR2:    DFS     1                       ; Y-Address2 Buffer
LINE_CNT:   DFS     1                       ; Line LCD Counter
POST_CNT:   DFS     1                       ; Write LCD Position Counter

            CPU     "8051.TBL"
            HOF     "INT8"
            ORG     2200H                   ; Strat Program For "ET-DEBUG31"

MAIN:       MOV     R2,#02H                 ; Power-on Delay
PWR_DLY1:   MOV     R3,#00H
PWR_DLY2:   MOV     R4,#00H
            DJNZ    R4,$
            DJNZ    R3,PWR_DLY2
            DJNZ    R2,PWR_DLY1
            ;
            LCALL   INITGLCD                ; Initial Graphic LCD
            MOV     LINE_CNT,#8             ; Counter Line
            MOV     DPTR,#TAB_SCOPE         ; Table Picture Oscillo Scope
            ;
NEW_LINE:   LCALL   SET_X1                  ; Set X_Address Page1
            LCALL   SET_Y1                  ; Set Y_Address Page1
            MOV     POST_CNT,#64            ; Counter Y Position Page1
WR_PAGE1:   LCALL   BUSY_LCD1
            CLR     A
            MOVC    A,@A+DPTR               ; Get Data-Font
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_DATA1          ; Write Data Page1
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            INC     DPTR
            DJNZ    POST_CNT,WR_PAGE1
            ;
            LCALL   SET_X2                  ; Set X_Address Page2
            LCALL   SET_Y2                  ; Set Y_Address Page2
            MOV     POST_CNT,#64            ; Counter Y Position Page2
WR_PAGE2:   LCALL   BUSY_LCD2
            CLR     A
            MOVC    A,@A+DPTR               ; Get Data-Font
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_DATA2          ; Write Data Page2
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            INC     DPTR
            DJNZ    POST_CNT,WR_PAGE2
            ;
            INC     X_ADDR1                 ; Next Line Page1
            INC     X_ADDR2                 ; Next Line Page2
            DJNZ    LINE_CNT,NEW_LINE
            SJMP    $

;/***********************/;
;/* Initial Graphic LCD */;
;/***********************/;
;
INITGLCD:   LCALL   BUSY_LCD1               ; Wait LCD Busy
            MOV     DPTR,#WR_COMM1          ; Write Instruction1
            MOV     A,#3FH                  ; Display on-off1  X=1 ON,X=0 OFF
            MOVX    @DPTR,A
            ;
            LCALL   BUSY_LCD2               ; Wait LCD Busy
            MOV     DPTR,#WR_COMM2          ; Write Instruction2
            MOV     A,#3FH                  ; Display on-off2  X=1 ON,X=0 OFF
            MOVX    @DPTR,A
            ;
            LCALL   BUSY_LCD1               ; Wait LCD Busy
            MOV     DPTR,#WR_COMM1          ; Write Instruction1
            MOV     A,#0C0H                 ; Display Strat Page1
            MOVX    @DPTR,A
            ;
            LCALL   BUSY_LCD2               ; Wait LCD Busy
            MOV     DPTR,#WR_COMM2          ; Write Instruction2
            MOV     A,#0C0H                 ; Display Strat Page2
            MOVX    @DPTR,A
            ;
            CLR     A
            MOV     X_ADDR1,A               ; Start X-Address1 = 0
            MOV     X_ADDR2,A               ; Start X-Address2 = 0
            MOV     Y_ADDR1,A               ; Start Y-Address1 = 0
            MOV     Y_ADDR2,A               ; Start Y-Address2 = 0
            RET

;/*******************/;
;/* Set X-Address1  */;
;/* Input : X_ADDR1 */;
;/*       : (0..7)  */;
;/*******************/;
;
SET_X1:     PUSH    ACC
            LCALL   BUSY_LCD1               ; Wait LCD busy
            MOV     A,X_ADDR1
            ANL     A,#07H
            ORL     A,#0B8H
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_COMM1          ; Set X-Address Page1
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            POP     ACC
            RET

;/*******************/;
;/* Set X-Address2  */;
;/* Input : X_ADDR2 */;
;/*       : (0..7)  */;
;/*******************/;
;
SET_X2:     PUSH    ACC
            LCALL   BUSY_LCD2               ; Wait LCD busy
            MOV     A,X_ADDR2
            ANL     A,#07H
            ORL     A,#0B8H
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_COMM2          ; Set X-Address Page2
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            POP     ACC
            RET

;/*******************/;
;/* Set Y-Address1  */;
;/* Input : Y_ADDR1 */;
;/*       : (0..63) */;
;/*******************/;
;
SET_Y1:     PUSH    ACC
            LCALL   BUSY_LCD1       ; Wait LCD busy
            MOV     A,Y_ADDR1
            ANL     A,#63
            ORL     A,#40H
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_COMM1          ; Set Y-Address Page1
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            POP     ACC
            RET

;/*******************/;
;/* Set Y-Address2  */;
;/* Input : Y_ADDR2 */;
;/*       : (0..63) */;
;/*******************/;
;
SET_Y2:     PUSH    ACC
            LCALL   BUSY_LCD2       ; Wait LCD busy
            MOV     A,Y_ADDR2
            ANL     A,#63
            ORL     A,#40H
            PUSH    DPH
            PUSH    DPL
            MOV     DPTR,#WR_COMM2          ; Set Y-Address Page2
            MOVX    @DPTR,A
            POP     DPL
            POP     DPH
            POP     ACC
            RET

;/***********************/;
;/* Read Busy Flag LCD1 */;
;/***********************/;
;
BUSY_LCD1:  PUSH    DPL
            PUSH    DPH
            PUSH    ACC
            MOV     DPTR,#RD_COMM1
BUSY1:      MOVX    A,@DPTR
            JB      ACC.7,BUSY1
            POP     ACC
            POP     DPH
            POP     DPL
            RET

;/***********************/;
;/* Read Busy Flag LCD2 */;
;/***********************/;
;
BUSY_LCD2:  PUSH    DPL
            PUSH    DPH
            PUSH    ACC
            MOV     DPTR,#RD_COMM2
BUSY2:      MOVX    A,@DPTR
            JB      ACC.7,BUSY2
            POP     ACC
            POP     DPH
            POP     DPL
            RET

;/*******************************/;
;/* Demo Picture OPscillo Scope */;
;/*******************************/;
;
TAB_SCOPE:  DFB      0FFH,0FFH,007H,00BH,0F3H,013H,013H,013H
            DFB      013H,013H,013H,013H,013H,013H,013H,013H
            DFB      013H,013H,013H,013H,013H,013H,013H,013H
            DFB      013H,013H,013H,013H,013H,013H,013H,013H
            DFB      013H,013H,013H,013H,013H,013H,013H,013H
            DFB      013H,013H,013H,013H,013H,013H,013H,013H
            DFB      013H,013H,013H,013H,013H,013H,013H,013H
            DFB      013H,013H,013H,013H,013H,013H,013H,013H
            DFB      013H,013H,013H,013H,013H,013H,013H,013H
            DFB      013H,013H,013H,013H,013H,013H,013H,013H
            DFB      013H,013H,013H,013H,013H,013H,013H,013H
            DFB      013H,013H,013H,0F3H,00BH,007H,0FFH,0FFH
            DFB      003H,003H,003H,003H,003H,003H,003H,003H
            DFB      003H,003H,043H,083H,003H,003H,003H,0E3H
            DFB      003H,003H,083H,043H,003H,003H,003H,003H
            DFB      003H,003H,003H,003H,003H,003H,0FFH,0FFH
LINE2:      DFB      0FFH,0FFH,000H,000H,0FFH,000H,000H,000H
            DFB      000H,080H,060H,018H,004H,002H,001H,001H
            DFB      001H,002H,004H,018H,060H,080H,000H,000H
            DFB      000H,000H,000H,000H,000H,080H,060H,018H
            DFB      004H,002H,001H,001H,001H,002H,004H,018H
            DFB      060H,080H,000H,000H,000H,000H,000H,000H
            DFB      000H,080H,060H,018H,004H,002H,001H,001H
            DFB      001H,002H,004H,018H,060H,080H,000H,000H
            DFB      000H,000H,000H,000H,000H,080H,060H,018H
            DFB      004H,002H,001H,001H,001H,002H,004H,018H
            DFB      060H,080H,000H,000H,000H,000H,000H,000H
            DFB      000H,080H,060H,0FFH,000H,000H,0FFH,0FFH
            DFB      000H,000H,000H,000H,000H,044H,048H,071H
            DFB      01AH,00CH,004H,002H,002H,0E1H,011H,051H
            DFB      011H,0E2H,002H,004H,00CH,01AH,071H,048H
            DFB      044H,000H,000H,000H,000H,000H,0FFH,0FFH
LINE3:      DFB      0FFH,0FFH,000H,000H,0FFH,008H,008H,004H
            DFB      002H,001H,080H,000H,000H,000H,000H,000H
            DFB      000H,000H,000H,000H,080H,001H,002H,004H
            DFB      008H,008H,008H,004H,002H,001H,080H,000H
            DFB      000H,000H,000H,000H,000H,000H,000H,000H
            DFB      080H,001H,002H,004H,008H,008H,008H,004H
            DFB      002H,001H,080H,000H,000H,000H,000H,000H
            DFB      000H,000H,000H,000H,080H,001H,002H,004H
            DFB      008H,008H,008H,004H,002H,001H,080H,000H
            DFB      000H,000H,000H,000H,000H,000H,000H,000H
            DFB      080H,001H,002H,004H,008H,008H,008H,004H
            DFB      002H,001H,080H,0FFH,000H,000H,0FFH,0FFH
            DFB      000H,000H,000H,000H,000H,000H,000H,040H
            DFB      080H,000H,010H,0A0H,080H,040H,041H,079H
            DFB      041H,080H,0A0H,010H,000H,080H,040H,000H
            DFB      000H,000H,000H,000H,000H,000H,0FFH,0FFH
LINE4:      DFB      0FFH,0FFH,000H,000H,0FFH,001H,001H,001H
            DFB      001H,001H,0E3H,021H,021H,021H,021H,021H
            DFB      021H,021H,021H,021H,0E3H,001H,001H,001H
            DFB      001H,001H,001H,001H,001H,001H,0E3H,021H
            DFB      021H,021H,021H,021H,021H,021H,021H,021H
            DFB      0E3H,001H,001H,001H,001H,001H,001H,001H
            DFB      001H,001H,0E3H,021H,021H,021H,021H,021H
            DFB      021H,021H,021H,021H,0E3H,001H,001H,001H
            DFB      001H,001H,001H,001H,001H,001H,0E3H,021H
            DFB      021H,021H,021H,021H,021H,021H,021H,021H
            DFB      0E3H,001H,001H,001H,001H,001H,001H,001H
            DFB      001H,001H,0E3H,0FFH,000H,000H,0FFH,0FFH
            DFB      000H,000H,000H,000H,000H,011H,012H,01CH
            DFB      006H,003H,001H,000H,000H,038H,044H,054H
            DFB      044H,038H,000H,001H,003H,006H,01CH,012H
            DFB      011H,000H,000H,000H,000H,000H,0FFH,0FFH
LINE5:      DFB      0FFH,0FFH,000H,000H,0FFH,008H,008H,008H
            DFB      008H,008H,00FH,000H,000H,000H,000H,000H
            DFB      000H,000H,000H,000H,00FH,008H,008H,008H
            DFB      008H,008H,008H,008H,008H,008H,00FH,000H
            DFB      000H,000H,000H,000H,000H,000H,000H,000H
            DFB      00FH,008H,008H,008H,008H,008H,008H,008H
            DFB      008H,008H,00FH,000H,000H,000H,000H,000H
            DFB      000H,000H,000H,000H,00FH,008H,008H,008H
            DFB      008H,008H,008H,008H,008H,008H,00FH,000H
            DFB      000H,000H,000H,000H,000H,000H,000H,000H
            DFB      00FH,008H,008H,008H,008H,008H,008H,008H
            DFB      008H,008H,00FH,0FFH,000H,000H,0FFH,0FFH
            DFB      000H,000H,000H,000H,000H,070H,088H,0A8H
            DFB      088H,070H,000H,000H,000H,000H,000H,000H
            DFB      000H,000H,000H,000H,070H,088H,0A8H,088H
            DFB      070H,000H,000H,000H,000H,000H,0FFH,0FFH
LINE6:      DFB      0FFH,0FFH,038H,034H,033H,032H,032H,032H
            DFB      032H,032H,032H,032H,032H,032H,032H,032H
            DFB      032H,032H,032H,032H,032H,032H,032H,032H
            DFB      032H,032H,032H,032H,032H,032H,032H,032H
            DFB      032H,032H,032H,032H,032H,032H,032H,032H
            DFB      032H,032H,032H,032H,032H,032H,032H,032H
            DFB      032H,032H,032H,032H,032H,032H,032H,032H
            DFB      032H,032H,032H,032H,032H,032H,032H,032H
            DFB      032H,032H,032H,032H,032H,032H,032H,032H
            DFB      032H,032H,032H,032H,032H,032H,032H,032H
            DFB      032H,032H,032H,032H,032H,032H,032H,0F2H
            DFB      0F2H,032H,032H,033H,034H,038H,03FH,03FH
            DFB      030H,030H,030H,030H,030H,030H,030H,030H
            DFB      030H,030H,030H,030H,030H,030H,030H,030H
            DFB      030H,030H,030H,030H,030H,030H,030H,030H
            DFB      030H,030H,030H,030H,030H,030H,0FFH,0FFH
LINE7:      DFB      0FFH,0FFH,000H,000H,000H,000H,000H,040H
            DFB      020H,020H,020H,0C0H,000H,040H,020H,020H
            DFB      020H,0C0H,000H,040H,020H,0A0H,030H,02AH
            DFB      0C6H,000H,048H,0ACH,04AH,022H,0C4H,048H
            DFB      0A0H,014H,00CH,040H,020H,0A0H,020H,024H
            DFB      0C6H,006H,00AH,0F2H,002H,004H,044H,024H
            DFB      0A0H,020H,020H,0C0H,000H,040H,020H,0A0H
            DFB      030H,02AH,0C6H,000H,004H,006H,006H,00AH
            DFB      0F2H,002H,004H,0C4H,024H,0A0H,0A0H,020H
            DFB      0C0H,000H,000H,040H,020H,0C0H,000H,000H
            DFB      0FCH,000H,000H,000H,000H,000H,000H,0FFH
            DFB      0FFH,000H,000H,000H,000H,000H,000H,0E0H
            DFB      010H,0C8H,0E8H,0E8H,0C8H,010H,0E0H,000H
            DFB      000H,000H,000H,000H,000H,000H,000H,000H
            DFB      0E0H,010H,0C8H,0E8H,0E8H,0C8H,010H,0E0H
            DFB      000H,000H,000H,000H,000H,000H,0FFH,0FFH
LINE8:      DFB      0FFH,0FFH,0C0H,0C0H,0C0H,0C0H,0C0H,0C3H
            DFB      0C5H,0C4H,0C4H,0C3H,0C0H,0C3H,0C5H,0C4H
            DFB      0C4H,0C3H,0C0H,0C0H,0C3H,0C4H,0C1H,0C2H
            DFB      0C7H,0C0H,0C0H,0C0H,0C0H,0C3H,0C4H,0C4H
            DFB      0C3H,0C0H,0C0H,0C0H,0C3H,0C4H,0C1H,0C2H
            DFB      0C7H,0C0H,0C0H,0C3H,0C4H,0C0H,0C0H,0C3H
            DFB      0C4H,0C1H,0C2H,0C7H,0C0H,0C0H,0C3H,0C4H
            DFB      0C1H,0C2H,0C7H,0C0H,0C0H,0C0H,0C0H,0C0H
            DFB      0C3H,0C4H,0C0H,0C7H,0C1H,0C0H,0C0H,0C0H
            DFB      0C7H,0C0H,0C0H,0C2H,0C5H,0C4H,0C4H,0C4H
            DFB      0C3H,0C0H,0C0H,0C0H,0C0H,0C0H,0C0H,0FFH
            DFB      0FFH,0C0H,0C0H,0C0H,0C0H,0C0H,0C0H,0C1H
            DFB      0C2H,0C4H,0C5H,0C5H,0C4H,0C2H,0C1H,0C0H
            DFB      0C0H,0C0H,0C0H,0C0H,0C0H,0C0H,0C0H,0C0H
            DFB      0C1H,0C2H,0C4H,0C5H,0C5H,0C4H,0C2H,0C1H
            DFB      0C0H,0C0H,0C0H,0C0H,0C0H,0C0H,0FFH,0FFH

            END



