;/*********************************/;
;/* Demo Program For RS-232 (CH0) */;
;/* Hardware  :  ET-CPSB31 V2.0   */;
;/* Complier  :  Cross-32  V2.0   */;
;/*********************************/;
;
;/****************************/;
;/* Equate List Register CPU */;
;/****************************/;
;
P0:         EQU     080H
SP:         EQU     081H
DPL:        EQU     082H
DPH:        EQU     083H
PCON:       EQU     087H
TCON:       EQU     088H
TMOD:       EQU     089H
TL0:        EQU     08AH
TL1:        EQU     08BH
TH0:        EQU     08CH
TH1:        EQU     08DH
P1:         EQU     090H
SCON:       EQU     098H
SBUF:       EQU     099H
P2:         EQU     0A0H
IE:         EQU     0A8H
P3:         EQU     0B0H
IP:         EQU     0B8H
T2CON:      EQU     0C8H
RCAP2L:     EQU     0CAH
RCAP2H:     EQU     0CBH
TL2:        EQU     0CCH
TH2:        EQU     0CDH
PSW:        EQU     0D0H
ACC:        EQU     0E0H
B:          EQU     0F0H
;
P0.0:       EQU     080H
P0.1:       EQU     081H
P0.2:       EQU     082H
P0.3:       EQU     083H
P0.4:       EQU     084H
P0.5:       EQU     085H
P0.6:       EQU     086H
P0.7:       EQU     087H
IT0:        EQU     088H
IE0:        EQU     089H
IT1:        EQU     08AH
IE1:        EQU     08BH
TR0:        EQU     08CH
TF0:        EQU     08DH
TR1:        EQU     08EH
TF1:        EQU     08FH
P1.0:       EQU     090H
P1.1:       EQU     091H
P1.2:       EQU     092H
P1.3:       EQU     093H
P1.4:       EQU     094H
P1.5:       EQU     095H
P1.6:       EQU     096H
P1.7:       EQU     097H
RI:         EQU     098H
TI:         EQU     099H
RB8:        EQU     09AH
TB8:        EQU     09BH
REN:        EQU     09CH
SM2:        EQU     09DH
SM1:        EQU     09EH
SM0:        EQU     09FH
P2.0:       EQU     0A0H
P2.1:       EQU     0A1H
P2.2:       EQU     0A2H
P2.3:       EQU     0A3H
P2.4:       EQU     0A4H
P2.5:       EQU     0A5H
P2.6:       EQU     0A6H
P2.7:       EQU     0A7H
EX0:        EQU     0A8H
ET0:        EQU     0A9H
EX1:        EQU     0AAH
ET1:        EQU     0ABH
ES:         EQU     0ACH
ET2:        EQU     0ADH
EA:         EQU     0AFH
P3.0:       EQU     0B0H
P3.1:       EQU     0B1H
P3.2:       EQU     0B2H
P3.3:       EQU     0B3H
P3.4:       EQU     0B4H
P3.5:       EQU     0B5H
P3.6:       EQU     0B6H
P3.7:       EQU     0B7H
PX0:        EQU     0B8H
PT0:        EQU     0B9H
PX1:        EQU     0BAH
PT1:        EQU     0BBH
PS:         EQU     0BCH
PT2:        EQU     0BDH
T2CP:       EQU     0C8H
T2C:        EQU     0C9H
TR2:        EQU     0CAH
EXEN2:      EQU     0CBH
TLCK:       EQU     0CCH
RCLK:       EQU     0CDH
EXF2:       EQU     0CEH
TF2:        EQU     0CFH
P:          EQU     0D0H
OV:         EQU     0D2H
RS0:        EQU     0D3H
RS1:        EQU     0D4H
F0:         EQU     0D5H
AC:         EQU     0D6H
CY:         EQU     0D7H
ACC.0:      EQU     0E0H
ACC.1:      EQU     0E1H
ACC.2:      EQU     0E2H
ACC.3:      EQU     0E3H
ACC.4:      EQU     0E4H
ACC.5:      EQU     0E5H
ACC.6:      EQU     0E6H
ACC.7:      EQU     0E7H
B.0:        EQU     0F0H
B.1:        EQU     0F1H
B.2:        EQU     0F2H
B.3:        EQU     0F3H
B.4:        EQU     0F4H
B.5:        EQU     0F5H
B.6:        EQU     0F6H
B.7:        EQU     0F7H

            CPU     "8051.TBL"
            HOF     "INT8"
            ORG     2200H                   ; Strat Program For "ET-DEBUG31"

MAIN:       MOV     A,#0FDH                 ; Set baud rate 9600
            MOV     TH1,A
            MOV     TL1,A
            MOV     TMOD,#00100000B         ; Timer1 Mode 1
            CLR     ES                      ; Disable serial interupt
            CLR     ET1                     ; Disable timer1 interupt
            SETB    TR1                     ; Set timer1 control
            MOV     SCON,#01010000B         ; Serial mode 1
            ;
            LCALL   PRINT_SER
            DFB     0DH,0AH
            DFB     "Hardware : ET-CPSB31 V2.0",0DH,0AH
            DFB     "ETT CO.,LTD",0DH,0AH
            DFB     "Press Any Key For Echo Receive Data From Serial Port"
            DFB     0DH,0AH,00H
LOOP:       LCALL   RX_BYTE
            LCALL   TX_BYTE
            SJMP    LOOP

;*************************
;* Send 1-Byte to RS-232 *
;* Input   : ACC         *
;* Output  : Serial port *
;*************************
;
TX_BYTE:    PUSH   IE
            CLR    TI
            MOV    SBUF,A
            JNB    TI,$
            CLR    TI
            POP    IE
            RET

;****************************
;* Receive Data From RS-232 *
;* Input   :  Serial Port   *
;* Output  :  ACC           *
;****************************
;
RX_BYTE:    PUSH   IE
            JNB    RI,$             ; Wait data
            CLR    RI
            MOV    A,SBUF
            POP    IE
            RET

;************************************
;*  Print Data data to Serial Port  *
;*  to display buffer.              *
;*  Usage    : LCALL PRINT_SER      *
;*           : DB   'xxxx',00       *
;*  Register : ACC                  *
;*  Note     : last byte must be 00 *
;************************************
;
PRINT_SER:  POP     DPH
            POP     DPL
PRINT1:     CLR     A
            MOVC    A,@A+DPTR
            CJNE    A,#00H,PRINT2
            SJMP    PRINT3
PRINT2:     LCALL   TX_BYTE
            INC     DPTR
            SJMP    PRINT1
PRINT3:     PUSH    DPL
            PUSH    DPH
            RET

            END

